// ============================================================ //
#ifndef _MQ6801_IAP_CFG_H__
#define _MQ6801_IAP_CFG_H__
// ============================================================ //

void iap_boot( void);

/* -------------------------------------------------------------*/
// Normal boot start address
// 趨ʼλ
#define NORMAL_BOOT_ADDRESS		(0xe500)
/* -------------------------------------------------------------*/
// xf:
//      IAP LibraryYϴСsʹ1280Byte(500(hex))ĴС,
//      ʹ߾aʼλOλַ_ʼ,С춴λַ
//      LCF(Sample Link Command File)nѽOͬλַ
/* -------------------------------------------------------------*/ 

/*--------------------------------------------------------------*/
// UART Interface Select
// ̬1~2 ѡһΪ IAP UART ʹ

#define IAP_UART_TX90_RX91
//#define IAP_UART_TX91_RX90
/* -------------------------------------------------------------*/ 
// xf:
//      IAP_UART_TX90_RX91: ʹP9.0lͶ˿,P9.1ն˿
//      IAP_UART_TX91_RX90: ʹP9.1lͶ˿,P9.0ն˿
// 
//      ͨ첽շ(UART)MBԔx:
//
//      1.IAP_UART_90_PIN: P9.0˿Oֵ
//      2.IAP_UART_91_PIN: P9.1˿Oֵ
//      3.IAP_UART_UATCNG_VALUE: UARTƼĴOֵ(UATCNG)
/* -------------------------------------------------------------*/

/* -------------------------------------------------------------*/
// Baud rate select:
// ̬ѡһΪ IAP UART Baudrate Speedʹ
//
#define BAUDRATE_115200
//#define BAUDRATE_57600
//#define BAUDRATE_38400
//#define BAUDRATE_19200
//#define BAUDRATE_9600
//#define BAUDRATE_4800
/* -------------------------------------------------------------*/
// xf:
//      BAUDRATE_115200: Oͨ첽շ֮շʞ115200
//      BAUDRATE_57600:  Oͨ첽շ֮շʞ57600
//      BAUDRATE_38400:  Oͨ첽շ֮շʞ38400
//      BAUDRATE_19200:  Oͨ첽շ֮շʞ19200
//      BAUDRATE_9600:   Oͨ첽շ֮շʞ9600
//      BAUDRATE_4800:   Oͨ첽շ֮շʞ4800
//
//      ͨ첽շ֮շ(baud rate)MBԔx:
//
//      1.BAUDRATE_DR_VALUE: ʼĴ֮Oֵ
//      2.BAUDRATE_RTSEL_VALUE: RTʱ֮Oֵ
/*--------------------------------------------------------------*/

/*--------------------------------------------------------------*/
// UART control setting (parity / stop bit / even)
// O 1. (/o)żУ
//      2. (/ż)żУ
//      3. Ͷ˽λ
//      4. ն˽λ
//      
#define UART_CR1_VALUE       (0x00)
#define UART_CR2_VALUE       (0x00)
/*--------------------------------------------------------------*/
// :ożУ,Ͷ˽λ1λ,ն˽λ1λ
//      UART_CR1_VALUE = 0x00
//      UART_CR2_VALUE = 0x00
//
// :ożУ,Ͷ˽λ2λ,ն˽λ2λ
//      UART_CR1_VALUE = 0x20
//      UART_CR2_VALUE = 0x01
//
// :żУ,żУ,Ͷ˽λ1λ,ն˽λ1λ
//      UART_CR1_VALUE = 0x08
//      UART_CR2_VALUE = 0x00
//
// :żУ,żУ,Ͷ˽λ2λ,ն˽λ2λ
//      UART_CR1_VALUE = 0x28
//      UART_CR2_VALUE = 0x01
//
// :żУ,żżУ,Ͷ˽λ1λ,ն˽λ1λ
//      UART_CR1_VALUE = 0x18
//      UART_CR2_VALUE = 0x00
//
// :żУ,żżУ,Ͷ˽λ2λ,ն˽λ2λ
//      UART_CR1_VALUE = 0x38
//      UART_CR2_VALUE = 0x01
/* -------------------------------------------------------------*/

/* -------------------------------------------------------------*/
// Enable Boot PIN Setting: 
// ̬ѡһΪ IAP Boot ДǷʹ

 #define IAP_BOOT_PIN_P00
// #define IAP_BOOT_PIN_P01
// #define IAP_BOOT_PIN_P42
// #define IAP_BOOT_PIN_P43
// #define IAP_BOOT_PIN_P44
// #define IAP_BOOT_PIN_P45
// #define IAP_BOOT_PIN_P70
// #define IAP_BOOT_PIN_P71
// #define IAP_BOOT_PIN_P72
// #define IAP_BOOT_PIN_P75
// #define IAP_BOOT_PIN_P76
// #define IAP_BOOT_PIN_P77
// #define IAP_BOOT_PIN_P80
// #define IAP_BOOT_PIN_P81
/* -------------------------------------------------------------*/
// xf:
//      Ӷ˿ڽMBԔO:
//      1.IAP_BOOT_PIN_FC_REG:˿ڹܿƼĴλַ(PxFC)
//      2.IAP_BOOT_PIN_PU_REG:˿ƼĴλַ(PxPU)
//      3.IAP_BOOT_PIN_PD_REG:˿ƼĴλַ(PxPD)
//      4.IAP_BOOT_PIN_CR_REG:˿ƼĴλַ(PxCR)
//      5.IAP_BOOT_PIN_PRD_REG:˿ݼĴλַ(PxPRD)
//      6.IAP_BOOT_PIN_BIT:˿Bitλֵ
/* -------------------------------------------------------------*/

/* -------------------------------------------------------------*/
// IAP boot pin default level:
// 趨 IAP Boot ˿(ʼ)λ
// ʼ(Default) Oλ(High) = 0x01;
//               Oλ(Low)  = 0x00;
#define IAP_BOOT_GPIO_DEFAULT_HIGH_LOW (0x00)
/* -------------------------------------------------------------*/

/* -------------------------------------------------------------*/
// IAP boot pin enable level
// 趨 IAP Boot ˿()λ
// (Enable)  Oλ(High) = 0x01;
//               Oλ(Low)  = 0x00;
#define IAP_BOOT_GPIO_ENABLE_HIGH_LOW  (0x01)
/* -------------------------------------------------------------*/

/* -------------------------------------------------------------*/


// IAP Boot related data structure
typedef struct
{
	// Memory address related
	unsigned int    norBootAddr;
	
	// Boot pin related
	volatile unsigned char	 *ptrBootPinPU;     // pointer to Boot GPIO Pin Pull-Up register
	volatile unsigned char	 *ptrBootPinPD;     // pointer to Boot GPIO Pin Pull-Down register
	volatile unsigned char	 *ptrBootPinPRD;    // pointer to Boot GPIO Pin PRD register
	volatile unsigned char	 valBootDefaultHL; // pointer to Boot GPIO Default High/Low
	volatile unsigned char	 valBootEnableHL;  // pointer to Boot GPIO Enable High/Low
	unsigned char              valBootPinBit;                 // Ex 0x02 is Px2
	
	// UART releted
	volatile unsigned char    valUart90Pin;
	volatile unsigned char    valUart91Pin;
	volatile unsigned char    valUATCNG;
	
	volatile unsigned char    valUartDR;
	volatile unsigned char    valUartCR1;
	volatile unsigned char    valUartCR2;
	volatile unsigned char    valUartRTSEL;
	
	
}IAP_Define;


extern IAP_Define IAP_Dev_define;   // define IAP related registers & runtime variable

/* -------------------------------------------------------------*/
// IAP UART configure define detail
#ifdef IAP_UART_TX90_RX91
// 1. UART1 Tx: P90 Rx: P91        -->
#define IAP_UART_90_PIN         (0x01)
#define IAP_UART_91_PIN			(0x00)
#define IAP_UART_UATCNG_VALUE   (0x00)
#endif

#ifdef IAP_UART_TX91_RX90
// 2. UART1 Tx: P91 Rx: P90        -->
#define IAP_UART_90_PIN         (0x00)
#define IAP_UART_91_PIN			(0x01)
#define IAP_UART_UATCNG_VALUE   (0x01)
#endif 

/* -------------------------------------------------------------*/

/* -------------------------------------------------------------*/
// Baudrate define detail
#ifdef BAUDRATE_115200
#define BAUDRATE_DR_VALUE       (0x03)
#define BAUDRATE_RTSEL_VALUE    (0x04 << 3)
#endif

#ifdef BAUDRATE_57600
#define BAUDRATE_DR_VALUE       (0x08)
#define BAUDRATE_RTSEL_VALUE    (0x03 << 3)
#endif

#ifdef BAUDRATE_38400
#define BAUDRATE_DR_VALUE       (0x0C)
#define BAUDRATE_RTSEL_VALUE    (0x00 << 3)
#endif

#ifdef BAUDRATE_19200
#define BAUDRATE_DR_VALUE       (0x19)
#define BAUDRATE_RTSEL_VALUE    (0x00 << 3)
#endif

#ifdef BAUDRATE_9600
#define BAUDRATE_DR_VALUE       (0x33)
#define BAUDRATE_RTSEL_VALUE    (0x00 << 3)
#endif

#ifdef BAUDRATE_4800
#define BAUDRATE_DR_VALUE       (0x67)
#define BAUDRATE_RTSEL_VALUE    (0x00 << 3)
#endif

/* -------------------------------------------------------------*/

/* -------------------------------------------------------------*/
// Boot pin define register detail
#ifdef IAP_BOOT_PIN_P00
#define IAP_BOOT_PIN_FC_REG                      (0x0F34)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F27)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F00)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1A)
#define IAP_BOOT_PIN_PRD_REG                     (0x000D)
#define IAP_BOOT_PIN_BIT                         (0x01)
#endif

#ifdef IAP_BOOT_PIN_P01
#define IAP_BOOT_PIN_FC_REG                      (0x0F34)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F27)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F00)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1A)
#define IAP_BOOT_PIN_PRD_REG                     (0x000D)
#define IAP_BOOT_PIN_BIT                         (0x02)
#endif

#ifdef IAP_BOOT_PIN_P40
#define IAP_BOOT_PIN_FC_REG                      (0x0F38)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2B)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F04)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1E)
#define IAP_BOOT_PIN_PRD_REG                     (0x0011)
#define IAP_BOOT_PIN_BIT                         (0x01)
#endif

#ifdef IAP_BOOT_PIN_P41
#define IAP_BOOT_PIN_FC_REG                      (0x0F38)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2B)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F04)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1E)
#define IAP_BOOT_PIN_PRD_REG                     (0x0011)
#define IAP_BOOT_PIN_BIT                         (0x02)
#endif

#ifdef IAP_BOOT_PIN_P42
#define IAP_BOOT_PIN_FC_REG                      (0x0F38)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2B)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F04)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1E)
#define IAP_BOOT_PIN_PRD_REG                     (0x0011)
#define IAP_BOOT_PIN_BIT                         (0x04)
#endif

#ifdef IAP_BOOT_PIN_P43
#define IAP_BOOT_PIN_FC_REG                      (0x0F38)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2B)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F04)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1E)
#define IAP_BOOT_PIN_PRD_REG                     (0x0011)
#define IAP_BOOT_PIN_BIT                         (0x08)
#endif

#ifdef IAP_BOOT_PIN_P44
#define IAP_BOOT_PIN_FC_REG                      (0x0F38)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2B)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F04)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1E)
#define IAP_BOOT_PIN_PRD_REG                     (0x0011)
#define IAP_BOOT_PIN_BIT                         (0x10)
#endif

#ifdef IAP_BOOT_PIN_P45
#define IAP_BOOT_PIN_FC_REG                      (0x0F38)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2B)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F04)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F1E)
#define IAP_BOOT_PIN_PRD_REG                     (0x0011)
#define IAP_BOOT_PIN_BIT                         (0x20)
#endif

#ifdef IAP_BOOT_PIN_P70
#define IAP_BOOT_PIN_FC_REG                      (0x0F3B)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2E)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F07)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F21)
#define IAP_BOOT_PIN_PRD_REG                     (0x0014)
#define IAP_BOOT_PIN_BIT                         (0x01)
#endif

#ifdef IAP_BOOT_PIN_P71
#define IAP_BOOT_PIN_FC_REG                      (0x0F3B)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2E)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F07)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F21)
#define IAP_BOOT_PIN_PRD_REG                     (0x0014)
#define IAP_BOOT_PIN_BIT                         (0x02)
#endif

#ifdef IAP_BOOT_PIN_P72
#define IAP_BOOT_PIN_FC_REG                      (0x0F3B)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2E)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F07)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F21)
#define IAP_BOOT_PIN_PRD_REG                     (0x0014)
#define IAP_BOOT_PIN_BIT                         (0x04)
#endif

#ifdef IAP_BOOT_PIN_P75
#define IAP_BOOT_PIN_FC_REG                      (0x0F3B)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2E)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F07)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F21)
#define IAP_BOOT_PIN_PRD_REG                     (0x0014)
#define IAP_BOOT_PIN_BIT                         (0x20)
#endif

#ifdef IAP_BOOT_PIN_P76
#define IAP_BOOT_PIN_FC_REG                      (0x0F3B)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2E)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F07)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F21)
#define IAP_BOOT_PIN_PRD_REG                     (0x0014)
#define IAP_BOOT_PIN_BIT                         (0x40)
#endif

#ifdef IAP_BOOT_PIN_P77
#define IAP_BOOT_PIN_FC_REG                      (0x0F3B)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2E)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F07)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F21)
#define IAP_BOOT_PIN_PRD_REG                     (0x0014)
#define IAP_BOOT_PIN_BIT                         (0x80)
#endif

#ifdef IAP_BOOT_PIN_P80
#define IAP_BOOT_PIN_FC_REG                      (0x0F3C)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2F)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F08)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F22)
#define IAP_BOOT_PIN_PRD_REG                     (0x0015)
#define IAP_BOOT_PIN_BIT                         (0x01)
#endif

#ifdef IAP_BOOT_PIN_P81
#define IAP_BOOT_PIN_FC_REG                      (0x0F3C)       //P0FC register address
#define IAP_BOOT_PIN_PU_REG                      (0x0F2F)       //P0 Pull-Up register address
#define IAP_BOOT_PIN_PD_REG                      (0x0F08)       //P0 Pull-Down register address
#define IAP_BOOT_PIN_CR_REG                      (0x0F22)
#define IAP_BOOT_PIN_PRD_REG                     (0x0015)
#define IAP_BOOT_PIN_BIT                         (0x02)
#endif

// ============================================================ //
#endif
// ============================================================ //
// 
// 

